Subject: Re: [Cellar] defining how to define codec support

From: Jerome Martinez <[email-masked]>
Date: Tue, 3 Jan 2017 18:32:07 +0100

Le 31/12/2016 à 20:53, [email-masked] a écrit :
> Hi all,
>
>  From comments on the recent subtitle definition, I drafted a pull request [1] to better document how to define codec support in Matroska. Mostly this adds a new section called “Defining Matroska Codec Support” which is reviewable at GitHub in rendered form [2]. I started to document how to construct a Codec ID and broke it down into the concepts of a Prefix, Major ID, Minor ID, Micro ID, and Delimiter. If any ABNF authors want to volunteer, it may be useful to rework the Codec ID definition in ABNF.

I added some comments in the PR, the most important one being that I 
think the proposal is too limitative, and we should let each ID free to 
define what is after "/".
I suggest:
"Codec ID Prefix"_"Major Codec ID"/ "Codec ID Specific"
(the "/" + right part being optional)

> I also divided the vague concept of Codec Description into three parts Description, Citation (we should reference the specification of the codec), and Initialization (to specifically define the data to be stored in CodecPrivate or CodecState).
>
> Once the above revisions are supported, we can rework the existing codec specs into this form.
>
> Also I notice that in many places the word “Codec” is used when it seems that “Encoding” is intended. For instance if many Codecs all encode the same encoding, then the Codec ID for each it the same although the Codecs are different. Should this be the Encoding ID?

"Codec" wording was from the beginning of the digital world a bad 
confusion between a format and a Coder/Decoder, and nowadays it is 
difficult to "fix" that.
I have mixed feeling between "Codec ID" being the most used word so easy 
to understand for people despite it is wrong vs the correct "Encoding 
ID3 being not classic despite it is the right word.

Jérôme